﻿Option Explicit On
Option Strict On

Imports System.Data.SqlClient

Module mdlMain

   Sub Main()
      Console.WriteLine("Demo: Daten aus SQL-Server Datenbank (Northwind) auslesen (VB)")
      Console.WriteLine("")

      Using cn As New SqlConnection( _
            "Data Source=DEVLAPTOP;" & _
            "Initial Catalog=Northwind;" & _
            "Integrated Security=True")

         Dim cmd As SqlCommand = Nothing
         Dim dr As SqlDataReader = Nothing

         Try
            cn.Open()
            cmd = New SqlCommand("SELECT * FROM dbo.Employees", cn)
            dr = cmd.ExecuteReader
            While dr.Read
               Console.WriteLine("{0} | {1}", _
                  dr("LastName").ToString.PadLeft(15), _
                  dr("FirstName").ToString _
                  )
            End While
            'Wichtig - DataReader immer wieder schließen!
            dr.Close()
         Catch sqlEx As SqlException
            Console.WriteLine("SQL-Fehler: " & sqlEx.Message)
         Catch ex As Exception
            Console.WriteLine("Allgemeiner Fehler: " & ex.Message)
         Finally
            cn.Close()
         End Try
         cn.Close()
      End Using

      Console.WriteLine("")
      Console.WriteLine("Return drücken ...")
      Console.ReadLine()
   End Sub

   ''' <summary>
   ''' Nicht auf Funktionalität getrimmt - Code-Beispiel aus der Präsentation
   ''' </summary>
   Sub Transaction_Beispiel()
      Using cn As New SqlConnection(My.Settings.DB)
         Dim cmd As New SqlCommand()
         Dim cmdAktion_1 As SqlCommand = New SqlCommand("...")
         Dim cmdAktion_2 As SqlCommand = New SqlCommand("...")
         cn.Open()
         Dim tr As SqlTransaction = cn.BeginTransaction()
         Try
            cmdAktion_1.ExecuteNonQuery()
            cmdAktion_2.ExecuteNonQuery()
            tr.Commit()
         Catch xcpSql As SqlException
            tr.Rollback()
         Finally
            cn.Close()
         End Try
      End Using
   End Sub

End Module
