﻿using System;
using System.Data.OleDb;
using System.Configuration;

namespace Demo_2b_JET_Console_CS
{
   class cMain
   {
      static void Main(string[] args)
      {
         Console.WriteLine("Demo: Daten aus Access-Datenbank (Northwind) auslesen (C#)");
         Console.WriteLine("");

         using (OleDbConnection cn = new OleDbConnection())
         {
            cn.ConnectionString = 
               ConfigurationManager.ConnectionStrings["DB"].ToString();

            OleDbCommand cmd = null;
            OleDbDataReader dr = null;

            try
            {
               cn.Open();
               cmd = new OleDbCommand("SELECT * FROM Employees", cn);
               dr = cmd.ExecuteReader();
               while (dr.Read())
               {
                  Console.WriteLine("{0} | {1}", 
                     Convert.ToString(dr["LastName"]).PadLeft(15), 
                     Convert.ToString(dr["FirstName"]));
               }
               //Wichtig - DataReader immer wieder schließen!
               dr.Close();
            }
            catch (OleDbException jetEx)
            {
               Console.WriteLine("SQL-Fehler: " + jetEx.Message);
            }
            catch (Exception ex)
            {
               Console.WriteLine("Allgemeiner Fehler: " + ex.Message);
            }
            finally
            {
               cn.Close();
            }
         }

         Console.WriteLine("");
         Console.WriteLine("Return drücken ...");
         Console.ReadLine();
      }
   }
}
