﻿Option Explicit On
Option Strict On

Public Class frm02_Categories

   'Eigenes Tracking für den "Dirty"-Status im DataRepeater
   Private _fDirty As Boolean = False

   'Code vom Assistenten (nicht geändert)
   Private Sub CategoriesBindingNavigatorSaveItem_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles CategoriesBindingNavigatorSaveItem.Click
      Me.Validate()
      Me.CategoriesBindingSource.EndEdit()
      Me.TableAdapterManager.UpdateAll(Me.DsNorthwind)
   End Sub

   'Code vom Assistenten (nicht geändert)
   Private Sub frmCategories_Load( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles MyBase.Load
      'TODO: This line of code loads data into the 'DsNorthwind.Categories' table. 
      'You can move, or remove it, as needed.
      Me.CategoriesTableAdapter.Fill(Me.DsNorthwind.Categories)
      CategoriesBindingSource_CurrentChanged(Nothing, EventArgs.Empty)
   End Sub

   'Code vom Assistenten (nicht geändert).
   '
   'Nur für's Beispiel hier belassen - würde normalerweise keinen Sinn machen.
   'Hintergrund: Die Assistenten erzeugen beim Ziehen des DataRepeaters auf's Formular den 
   '             hiermit verbundenen Toolstrip, über den die Detailsicht geladen wierden kann.
   Private Sub FillToolStripButton_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles FillToolStripButton.Click
      Try
         Me.ProductsTableAdapter.Fill(Me.DsNorthwind.Products, _
               New System.Nullable(Of Integer) _
               (CType(CategoryIDToolStripTextBox.Text, Integer)))
      Catch ex As System.Exception
         System.Windows.Forms.MessageBox.Show(ex.Message)
      End Try

   End Sub

   'Master: "Current-Event": Bild im Master anzeigen; Detail (Endlosform) befüllen
   Private Sub CategoriesBindingSource_CurrentChanged( _
               ByVal sender As Object, ByVal e As System.EventArgs) _
               Handles CategoriesBindingSource.CurrentChanged
      'Dieser Event wird auch bei der Initialisierung angesprungen - was zu einem Fehler führen würde,
      'ergo verlassen, falls der Master noch keinen Datensatz anzeigt.
      If CategoriesBindingSource.Position < 0 Then Return

      'Bild anzeigen
      If DsNorthwind.Categories.Item(CategoriesBindingSource.Position).Picture _
               Is DBNull.Value Then
         pbImage.Image = Nothing
      Else
         Dim arrPicture() As Byte = _
            CType(DsNorthwind.Categories.Item(CategoriesBindingSource.Position).Picture, _
            Byte() _
         )
         'Normalerweise beinhalten BLOBs nur das Bild selbst.
         'In der Notrhwind-DB ist das nicht der Fall (wohl wegen 
         'Konvertierung bzw. Übernahme der Daten aus Access),
         'hier gibt's einen 78-byte Header zu Beginn eines jeden
         'Bildes - diese müssen übersprungen bzw. ausgelassen werden.
         '
         'Regulär würde das Vorgehen so aussehen:
         'Dim ms As New IO.MemoryStream(arrPicture)
         'Dim img As Image = Image.FromStream(ms)
         'ms.Close()
         'pbImage.Image = img
         '
         'Mit der Northwind aber so:
         Dim ms As New IO.MemoryStream()
         Dim intOffset As Integer = 78
         ms.Write(arrPicture, intOffset, arrPicture.Length - intOffset)
         Dim img As Image = Image.FromStream(ms)
         ms.Close()
         pbImage.Image = img
      End If

      'Produkte (Detail / DataRepeater) anzeigen
      If Not CategoryIDTextBox.Text.Equals(String.Empty) Then
         Me.ProductsTableAdapter.Fill(Me.DsNorthwind.Products, _
               CType(CategoryIDTextBox.Text, Integer))
      End If
   End Sub

   Private Sub dareProducts_CurrentItemIndexChanged( _
               ByVal sender As System.Object, ByVal e As System.EventArgs) _
               Handles dareProducts.CurrentItemIndexChanged
      If _fDirty Then '<- dareProducts.IsCurrentItemDirty 
         Me.Validate()
         Me.ProductsBindingSource.EndEdit()
         Me.TableAdapterManager.UpdateAll(Me.DsNorthwind)
      End If
      _fDirty = False
   End Sub

   'Nachverfolgung gemachter Änderungen - wird angesprungen, sobald der Benutzer
   'eine Änderung in einem der Controls vornimmt.
   Private Sub Control_Validating( _
         ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) _
         Handles ProductNameTextBox.Validating, QuantityPerUnitTextBox.Validating, _
                 UnitPriceTextBox.Validating, DiscontinuedCheckBox.Validating
      _fDirty = True
   End Sub

End Class