﻿Option Explicit On
Option Strict On

Imports System.Data
Imports System.Data.Sql
Imports System.Data.SqlClient
Imports Microsoft.VisualBasic

''' <summary>
''' Implementiert Basismethoden für Verbindungen zum SQL Server
''' </summary>
Public Class cSQLS_Base

   Friend _cn As SqlConnection

   Friend ReadOnly Property DB_Connection() As SqlConnection
      Get
         Return _cn
      End Get
   End Property

   Public Sub New()
      'Verbindung zur SQL-DB initialisieren

      'ConnectionString aus der Settings-Datei (app[.exe].config) auslesen
      Dim strConnectionString As String = My.Settings.SQLS_DB

      'Falls Benutzer und Kennwort immer gleich sein sollen, diese Information aber nicht direkt in der
      'Settings-Datei hinterlegt werden sollen, können diese hier eingefügt werden (auskommentierten Code 
      'wieder aktivieren)
      Dim cnsBuilder As New SqlConnectionStringBuilder(strConnectionString)
      'cnsBuilder.Password = ""
      'cnsBuilder.UserID = ""

      'Lokale Verbindung initialisieren
      _cn = New SqlConnection(cnsBuilder.ConnectionString)
   End Sub

   Protected Overrides Sub Finalize()
      'Aufräumen ...
      If Not _cn Is Nothing AndAlso _cn.State <> ConnectionState.Closed Then
         Try
            _cn.Close()
         Catch ex As Exception
         End Try
      End If

      MyBase.Finalize()
   End Sub

End Class
