﻿Option Explicit On
Option Strict On

Imports System
Imports System.Data
Imports System.Data.SqlClient

Public Class frm04_CustomerPhoneList

   'Beinhaltet alle Daten und dient gleichzeitig als Instrument zur Sortierung 
   'wie auch Filterung.
   Private _dv As DataView
   '

   Private Sub frmCustomerPhoneList_Load( _
               ByVal sender As System.Object, ByVal e As System.EventArgs) _
               Handles MyBase.Load
      'Daten (einmalig) einlesen
      Dim dt As New DataTable("tblCustomerPhoneNumbers")
      Using cn As New SqlConnection(My.Settings.SQLS_DB)
         Dim cmd As SqlCommand = Nothing
         Dim da As SqlDataAdapter = Nothing

         Try
            cn.Open()
            cmd = New SqlCommand( _
               "SELECT CompanyName, ContactName, Phone, Fax " & _
               "FROM dbo.Customers", cn)
            da = New SqlDataAdapter(cmd)
            da.Fill(dt)
         Catch sqlEx As SqlException
            MessageBox.Show("SQL-Fehler: " & sqlEx.Message, _
               Application.ProductName & ": Fehler", MessageBoxButtons.OK, _
               MessageBoxIcon.Exclamation)
         Catch ex As Exception
            MessageBox.Show("Allgemeiner Fehler: " & ex.Message, _
               Application.ProductName & ": Fehler", MessageBoxButtons.OK, _
               MessageBoxIcon.Exclamation)
         Finally
            cn.Close()
         End Try
         cn.Close()
      End Using

      'DataView initialisieren (mit Daten aus der gerade befüllten Tabelle füllen)
      _dv = New DataView(dt)

      'Die Sortierung initial setzen - dank der Verwendung innerhalb eines GridViews 
      'kann die Sortierung auch vom Benutzer selbst zur Laufzeit geändert werden 
      '(per Klick auf einen Spaltenkopf).
      _dv.Sort = "CompanyName"

      'Filter initialisieren 
      Dim tgl As RadioButton
      tgl = tgl_A
      'Alternativ auch mit allen:
      'tgl = tgl_Alle

      'O.a. ToggleButton setzen und das Grid mit den gefilterten Daten befüllen
      tgl.Checked = True
      Filter_Click(tgl, EventArgs.Empty)
   End Sub

   'Wird beim Klick auf einen der ToggleButtons aufgerufen
   Private Sub Filter_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
               tgl_A.Click, tgl_B.Click, tgl_C.Click, tgl_D.Click, tgl_E.Click, _
               tgl_F.Click, tgl_G.Click, tgl_H.Click, tgl_I.Click, tgl_J.Click, _
               tgl_K.Click, tgl_L.Click, tgl_M.Click, tgl_N.Click, tgl_O.Click, _
               tgl_P.Click, tgl_Q.Click, tgl_R.Click, tgl_S.Click, tgl_T.Click, _
               tgl_U.Click, tgl_V.Click, tgl_W.Click, tgl_X.Click, tgl_Y.Click, _
               tgl_Z.Click, tgl_Alle.Click
      Dim strFilter_SQL_Where As String = String.Empty
      If ReferenceEquals(sender, tgl_Alle) Then
         'Filter zurücksetzen (alle anzeigen)
         strFilter_SQL_Where = String.Empty
      Else
         Dim strFilter_Auswahl As String = _
            Microsoft.VisualBasic.Right(DirectCast(sender, RadioButton).Name, 1)
         Dim strFilter_Buchstaben As String = String.Empty
         Select Case strFilter_Auswahl.ToUpper

            Case "A" : strFilter_Buchstaben = "AÀÁÂÃÄ"  '\
            Case "C" : strFilter_Buchstaben = "CÇ"      ' \
            Case "E" : strFilter_Buchstaben = "EÈÉÊË"   '  \
            Case "I" : strFilter_Buchstaben = "IÌÍÎÏ"   '   \
            Case "N" : strFilter_Buchstaben = "NÑ"      '     Zeichen, die mehrfache Aus-
            Case "O" : strFilter_Buchstaben = "OÒÓÔÕÖ"  '     prägungen aufweisen, explizit
            Case "S" : strFilter_Buchstaben = "SŠ"      '   / besetzen
            Case "U" : strFilter_Buchstaben = "UÙÚÛÜ"   '  /
            Case "Y" : strFilter_Buchstaben = "YÝÿ"     ' /
            Case "Z" : strFilter_Buchstaben = "ZÆØÅ"    '/
               'Alle anderen Zeichen: nur("einfach")
            Case Else : strFilter_Buchstaben = strFilter_Auswahl
         End Select

         'WHERE-Bedingung zusammenbauen (leider "versteht" der RowFilter keine 
         'Ausdrücke á la "Left(x,y) = ...")
         Dim sb As New System.Text.StringBuilder
         For intCounter As Integer = 0 To (strFilter_Buchstaben.Length - 1)
            If sb.Length > 0 Then sb.Append("OR ")
            sb.Append("CompanyName LIKE '" & strFilter_Buchstaben.Chars(intCounter) & _
                      "*' ")
         Next
         strFilter_SQL_Where = sb.ToString
      End If

      'Filter zuweisen oder, im Fall von tgl_Alle, zurücksetzen
      _dv.RowFilter = strFilter_SQL_Where

      'GridView - Daten zuweisen
      dgv.DataSource = _dv

      'Alle Spalten: Breite dem Inhalt anpassen
      For Each col As DataGridViewColumn In dgv.Columns
         col.AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
      Next
   End Sub

End Class
